!= Module StoreMom
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: storemom.f90,v 1.1 2011-02-28 12:19:41 sugiyama Exp $ 
! Tag Name::  $Name: arare4-20110302-3 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ư̤˴ؤѻͤݴɤ뤿ѿ⥸塼
!(2010ǯ12ɲ)
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module StoreMom
  !
  !ư̤˴ؤѻͤݴɤ뤿ѿ⥸塼.
  !

  !⥸塼ɤ߹
  use gridset, only:   DimXMin,     & ! x β
    &                  DimXMax,     & ! x ξ
    &                  DimZMin,     & ! z β
    &                  DimZMax,     & ! z ξ
    &                  SpcNum,      & ! number of species
    &                  RegXMin,     & ! x ʪΰβ
    &                  RegXMax        ! x ʪΰξ
  use TimeSet, only:   TimeDisp,    & ! ϻֳִ
    &                  DelTimeLong    ! Ĺ֥ƥå

  !ۤηػ
  implicit none

  !°λ
  private

  !
  public StoreMom_Init, StoreMomMeanX, StoreMomClean
  public z_MomAdv,  z_MomTurb, z_MomDiff, z_MomFlux
  public pz_MomAdv,  pz_MomTurb, pz_MomDiff, pz_MomFlux
  public StoreMomAdv, StoreMomTurb, StoreMomDiff, StoreMomFlux

  !ѿ
  real(8), allocatable :: z_MomAdv(:)
  real(8), allocatable :: z_MomTurb(:)
  real(8), allocatable :: z_MomDiff(:)
  real(8), allocatable :: z_MomFlux(:)
  real(8), allocatable :: pz_MomAdv(:,:)
  real(8), allocatable :: pz_MomTurb(:,:)
  real(8), allocatable :: pz_MomDiff(:,:)
  real(8), allocatable :: pz_MomFlux(:,:)

  !save °
  save pz_MomAdv, pz_MomTurb, pz_MomDiff, pz_MomFlux
  save z_MomAdv, z_MomTurb, z_MomDiff, z_MomFlux

contains

  subroutine StoreMom_Init( )
    !롼

    allocate(     &
      & z_MomAdv(DimZMin:DimZMax),  & 
      & z_MomTurb(DimZMin:DimZMax), &
      & z_MomDiff(DimZMin:DimZMax), &
      & z_MomFlux(DimZMin:DimZMax), &
      & pz_MomAdv(DimXMin:DimXMax, DimZMin:DimZMax),  & 
      & pz_MomTurb(DimXMin:DimXMax, DimZMin:DimZMax), &
      & pz_MomDiff(DimXMin:DimXMax, DimZMin:DimZMax), &
      & pz_MomFlux(DimXMin:DimXMax, DimZMin:DimZMax)  &
      &  )

    call StoreMomClean

  end subroutine StoreMom_Init


  subroutine StoreMomClean( )
    !ݴɤͤΥꥢ
    
    z_MomAdv  = 0.0d0
    z_MomTurb = 0.0d0
    z_MomDiff = 0.0d0
    z_MomFlux = 0.0d0

    pz_MomAdv  = 0.0d0
    pz_MomTurb = 0.0d0
    pz_MomDiff = 0.0d0
    pz_MomFlux = 0.0d0
   
!    CalNum  = 1.0d-40    !ػ. 
  end subroutine StoreMomClean


  subroutine StoreMomMeanX( )
    !ݴɤͤοʿʿ [kg.m/s^2]
    real(8) :: CalNum

    CalNum = TimeDisp / DelTimeLong 
    
    z_MomAdv  = a_MeanX_aa( pz_MomAdv )   / CalNum
    z_MomTurb = a_MeanX_aa( pz_MomTurb )  / CalNum
    z_MomDiff = a_MeanX_aa( pz_MomDiff )  / CalNum
    z_MomFlux = a_MeanX_aa( pz_MomFlux )  / CalNum

  end subroutine StoreMomMeanX

  subroutine StoreMomAdv( Work )
    !ήݴ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2  = pz_MomAdv + Work
    pz_MomAdv = Work2

  end subroutine StoreMomAdv


  subroutine StoreMomTurb( Work )
    !ήݴ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = pz_MomTurb + Work
    pz_MomTurb = Work2

  end subroutine StoreMomTurb


  subroutine StoreMomDiff( Work )
    !ͳȻݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = pz_MomDiff + Work
    pz_MomDiff = Work2

  end subroutine StoreMomDiff

  subroutine StoreMomFlux( Work )
    !ư̥եåݴ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2  = pz_MomFlux + Work
    pz_MomFlux = Work2

  end subroutine StoreMomFlux

  function a_MeanX_aa( var ) 
    !
    ! ʿʿͤη׻
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: var(DimXMin:DimXMax, DimZMin:DimZMax)
                                     !ʿѱ黻оݤȤʤѿ
    real(8)              :: a_MeanX_aa(DimZMin:DimZMax)
                                     !ʿʿ

    a_MeanX_aa = sum( var(RegXMin+1:RegXMax, :), 1 ) &
      &           / real(RegXMax - RegXMin, 8) 

  end function a_MeanX_aa

  function aa_MeanX_aaa( var ) 
    !
    ! ʿʿͤη׻
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: var(DimXMin:DimXMax, DimZMin:DimZMax, 1:SpcNum)
                                     !ʿѱ黻оݤȤʤѿ
    real(8)              :: aa_MeanX_aaa(DimZMin:DimZMax, 1:SpcNum)
                                     !ʿʿ

    aa_MeanX_aaa = sum( var(RegXMin+1:RegXMax, :, :), 1 ) &
      &           / real(RegXMax - RegXMin, 8) 

  end function aa_MeanX_aaa
  

end module StoreMom
